*#### ANSI .t.    !!!!
#include "Gra.ch"
#include "Xbp.ch"

#include "activex.ch"
#include "udc.ch"

// Beispiel aus der Hilfe zu XbpPrinter() abgewandelt.

PROCEDURE Main
   LOCAL oPS := NIL, oUDC := NIL, oPRN := NIL, oPRO := NIL
   LOCAL cDir // wir mssen das komplette Verzeichnis vorgeben

   SET CHARSET TO ANSI

   cDir := CurDrive()+":\"+CurDir()

   // Dim objUDC As IUDC
   // Set objUDC = New UDC.APIWrapper
   // das ist der Einstieg
   oUDC := CreateObject("UDC.APIWrapper")
   do case
      case oUDC == NIL
           msgbox("oUDC ist NIL")
           quit
      case ValType(oUDC) <> "O"
           msgbox("oUDC ist kein Objekt: "+ValType(oUDC))
           quit
      otherwise
           msgbox("oUDC ist OK")
   end

   oUDC:ActivationMode := 0 /*silent*/
   oUDC:Activate()
   // will ich nicht ndern, machen wir ber Parameter von PrinterPS()
   //                          ==>    oDC:Create( cPrinterObjectName )
   // oUDC:DefaultPrinter := "Universal Document Converter"

   // bei Excel wird einer Xbase++ Variablen ein oBook, oSheet zugewiesen ...

   // hier holen wir den Pointer zu dem gewnschten Drucker
   // Dim itfPrinter As IUDCPrinter
   // Set itfPrinter = objUDC.Printers("Universal Document Converter")
   oPRN := oUDC:Printers("Universal Document Converter")

   // nun brauchen wir das Profil
   // Dim itfProfile As IProfile
   // Set itfProfile = itfPrinter.Profile
   oPRO := oPRN:Profile

   // Profil Laden ... bei mir war das nicht vorhanden.
   // itfProfile.Load ("C:\Program Files\Universal Document Converter\UDC Profiles\Drawing to TIFF.xml")

   // TIFF drucken
   oPRO:Load (cDir+"\UDC-TIFF.xml")

   oPRO:OutputLocation:Mode       := LM_PREDEFINED
   oPRO:OutputLocation:FolderPath := "D:\TEMP"
   oPRO:PostProcessing:Mode       := PP_OPEN_FOLDER

   // Presentation-Space fr Standard-Drucker erzeugen
   oPS := PrinterPS("Universal Document Converter")

   // Spooler aktivieren
   oPS:device():startDoc()

   // Grafische Ausgabe zum Spooler schicken
   GraBox( oPS,      { 50,1200}, {600,200} )
   GraStringAt( oPS, {150,1100}, "Grafik wird gedruckt auf:")
   GraStringAt( oPS, {150,1050}, oPS:device():devName       )

   // Spoolen beenden
   oPS:device():endDoc()

   DestroyDevice( oPS )

   // zurcksetzen

   // PDF drucken, oder ein Standard.xml ...
   oPRO:Load (cDir+"\UDC-PDF.xml")

   // aufrumen

   oUDC := NIL
   oPRN := NIL
   oPRO := NIL


RETURN

// Presentation-Space erzeugen und mit Device-Context
// fr einen Drucker assoziieren. Die Einheit fr das
// Koordinatensystem ist 1/10 Millimeter

FUNCTION PrinterPS( cPrinterObjectName )
   LOCAL oPS, oDC := XbpPrinter():New()
   LOCAL aSize
   oDC:Create( cPrinterObjectName )
   oPS   := XbpPresSpace():New()
   aSize := oDC:paperSize()
   // Gre des bedruckbaren Bereichs
   aSize := { aSize[5] - aSize[3], ;
              aSize[6] - aSize[4]  }
   oPS:Create( oDC, aSize, GRA_PU_LOMETRIC )
RETURN oPS

PROCEDURE DestroyDevice( oPS )
   LOCAL oDC := oPS:device()
   IF oDC <> NIL
      oPS:configure()
      oDC:destroy()
   ENDIF
RETURN





